/*
 * Copyright (c) 2005 Christophe Varoqui
 * Copyright (c) 2005 Edward Goggin, EMC
 */
#include <checkers.h>

#include "vector.h"
#include "structs.h"
#include "switchgroup.h"
#include "config.h"

extern int
select_path_group (struct multipath * mpp)
{
	int i, j;
	int highest = 0;
	int most_paths = 0;
	int bestpg = 1;
	struct pathgroup * pgp;
	struct path * pp;
	int priority, enabled_paths;

	if (!mpp->pg)
		return 1;
	
	vector_foreach_slot (mpp->pg, pgp, i) {
		if (!pgp->paths)
			continue;

		priority = 0;
		enabled_paths = 0;

		vector_foreach_slot (pgp->paths, pp, j) {
			if (pp->state != PATH_DOWN) {
				priority += pp->priority;
				enabled_paths++;
			}
		}
		if (conf->pg_prio_calc == PG_PRIO_CALC_AVG && enabled_paths)
			pgp->priority = priority / enabled_paths;
		else
			pgp->priority = priority;

		if (pgp->priority > highest) {
			highest = pgp->priority;
			most_paths = enabled_paths;
			bestpg = i + 1;
		}
		else if (pgp->priority == highest &&
			 conf->pg_prio_calc == PG_PRIO_CALC_AVG &&
			 enabled_paths > most_paths) {
			most_paths = enabled_paths;
			bestpg = i + 1;
		}
	}
	return bestpg;
}
